
import processing.serial.*;
static final int myScreenWidth = 760;
static final int myScreenHeight = 480;
static final int myMaxItems = 6;
static final float myMaxValue = 100;
static final float myMinValue = 0;


Serial myPort;        //とりあえず宣言してっください．
int xPos = 1;         // horizontal position of the graph

int[][] screenValue = new int[myMaxItems][myScreenWidth];

void setup () {
  // 画面の大きさ、小さいと観づらいです．
  size(myScreenWidth, myScreenHeight);        
  //繋がってるポートをリスト化、
  println(Serial.list());
  //Arduinoが繋がってるポートを下の[この中]に入れましょう．
  myPort = new Serial(this, Serial.list()[1], 9600);
  // don't generate a serialEvent() unless you get a newline character:
  myPort.bufferUntil('\n');
  for(int i = 0; i < myMaxItems; i++){
    for(int j = 0; j < myScreenWidth; j++){
      screenValue[i][j] = 0;
    }
  }
  colorMode( HSB );
  background(0);
}

int getColor(int numera, int denom)
{
  float step = 360.0 / denom;
  return (int)(255.0 * numera * step / 360.0);
}


void draw () {
// everything happens in the serialEvent()
}
 
void serialEvent (Serial myPort) {
  // get the ASCII string:
  String inString = myPort.readStringUntil('\n');

  if (inString != null) {
    // trim off any whitespace:
    inString = trim(inString);
    // convert to an int and map to the screen height:
    String list[] = split(inString, ',');
    if(xPos >= myScreenWidth - 1){
      for(int i = 0; i < myMaxItems; i++){
        for(int j = 0; j < myScreenWidth-1; j++){
          screenValue[i][j] = screenValue[i][j+1];
        }
      }
      xPos = myScreenWidth - 1;
    }
    
    for(int i = 0; i < list.length; i++){
      float num = float(list[i]);
      screenValue[i][xPos] = (int)map(num, myMinValue, myMaxValue, 0, myScreenHeight);
    }
    
    
    background(0);
    for(int i = 0; i < list.length; i++){
      int hue = getColor(i, list.length);
      for(int j = 1; j < xPos; j++){
        stroke(hue, 255, 255);
        line(j - 1, myScreenHeight - screenValue[i][j-1], j, myScreenHeight - screenValue[i][j]);
      }
      fill(hue, 255, 255);
      String s = String.format("%d:%.1f", i, map(screenValue[i][xPos],0, myScreenHeight, myMinValue, myMaxValue));
      text(s, 10, 20+20*i);
    }
    
    xPos++;
  }
}
